<?php
/*
 * Copyright (c) 2003-2005 by jmtrivial <jm DOT trivial AT free DOT fr>
 * AUTHOR:
 *    jmtrivial (http://jm.trivial.free.fr)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA, 02111-1301 USA
 */


$langues=array("fr"=>"franais", "en"=>"anglais", "es" => "espagnol", "de" => "allemand", "all" => "toutes les langues");



/* cette fonction supprime les accents, google n'en tenant pas compte,
 et leur prsence pouvant corrompre le fonctionnement du site
 (accents parfois remplacs par "?" dans les requetes)*/
function rm_accents($mot) {
  $temp = $mot;
  
  $pattern = "[]";
  $temp = eregi_replace($pattern,"a",$temp);
  $pattern = "[]";
  $temp = eregi_replace($pattern,"e",$temp);
  $pattern = "[]";
  $temp = eregi_replace($pattern,"i",$temp);
  $pattern = "[]";
  $temp = eregi_replace($pattern,"o",$temp);
  $pattern = "[]";
  $temp = eregi_replace($pattern,"u",$temp);
  $pattern = "[]";
  $temp = eregi_replace($pattern,"n",$temp);
  return($temp);
}

/* fonction retournant un mot au hasard suivant la langue choisie */
function randomword($lang) {
  /* on fait un premier random parmi les fichiers */
  $fichier_liste = file("liste/fichiers".$lang);      
  $nb_fichier=rand(1,rtrim($fichier_liste[0]));
  $fichier = file("liste/".rtrim($fichier_liste[$nb_fichier]));
  
  /* puis un second random parmi les mots du fichier */
  $nb_lignes = count($fichier);
  $ligne=rand(0,$nb_lignes-1);
  $mot=rtrim($fichier[$ligne]);
  
  return $mot;
}


/* fonction gnrant la liste des langues disponibles pour les recherches */
function liste_langues($lang) {
  global $langues;
  foreach($langues as $cle => $complet) {
	if ($lang != $cle)
	  echo "<a href=\"?lang=".$cle."\">".$complet."</a>";
	else
	  echo $complet;
	if ($cle != "all")
	  echo ", ";
  }  
}

/* entte de la page html */
function debut_html($ligne, $lang) {
  ?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
	<html>
	<head>
	<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" />
	<meta name="author" content="jm trivial" />
	<meta name="Generator" content="Xemacs" />
	<meta name="Description" content="Random Web Page" />
	<meta name="KeyWords" content="random web page, page au hasard, internet, promenade" />
	<title>Random Web Page</title>
	<link href="style.css" rel="stylesheet" type="text/css"/>
	<?php echo $ligne;?>
	</head>
		<body>
		
		<div class="head"><h1><strong class="white">Random</strong> Web Page</h1>
		</div>
		<div class="menu">
		<p class="liens">
		<a href="?apropos=1&amp;lang=<?php echo $lang;?>"> propos de ce site</a>
		</p>
		<p class="langues">
		<?php liste_langues($lang);?>
		</p>
			</div>
			<div class="corps">
<?php
}


/* pied de la page html */
function fin_html() {
  ?>
  </div>
	
<div class="pied"><p>Site valide
<a href="http://validator.w3.org/check/referer">XHTML </a>
et <a href="http://jigsaw.w3.org/css-validator/check/referer">CSS</a><br/>
Conception: <a href="http://jm.trivial.free.fr">Jm Trivial</a> - <a href="?codesource=1">Code source</a> - Dernire modification: 10 juillet 2005
</p>
</div>
</body>
</html>
<?php
}



/*
 * DBUT DU SCRIPT PROPREMENT DIT 
 */


/* choix de la langue */
if (isset($HTTP_GET_VARS["lang"])) {
  $lang=$HTTP_GET_VARS["lang"];
  if (!file_exists("liste/fichiers".$lang)) {
	$lang="fr";
  }
 }
 else {
   $lang="fr";
 }


/* Affichage du code source */
if (isset($HTTP_GET_VARS["codesource"])) {
   $codesource = file_get_contents("index.php");
   echo "<html><head><title \"code source de randomwebpage - Licence: GPL\"/></head><body><pre>";
   echo htmlspecialchars($codesource);
   echo "</pre></body></html>";
   
  return;
 }

/* Si une page alatoire est demande */
if (isset($HTTP_GET_VARS["randompage"])) {
  /* on supprime les accents d'un mot choisi alatoirement */
  $mot = rm_accents(randomword($lang));
  /* on gnre la requte http */
  if ($lang == "all")
	$url = "http://www.google.com/search?btnI=I%27m+Feeling+Lucky&amp;q=".$mot;
  else
	$url = "http://www.google.com/search?btnI=I%27m+Feeling+Lucky&amp;q=".$mot."&amp;lr=lang_".$lang;
  
  /* on affiche ventuellement les dtails */
  if (isset($HTTP_GET_VARS["detail"])) {
	debut_html("<meta http-equiv=\"Refresh\" content=\"5;url=".$url."\">", $lang);
	?>
	  <p><i>Ce site utilise une base de donnes de mots cls, et une fonction alatoire pour choisir le mot cl. Puis il utilise
		 la fonction <b>J'ai de la chance</b> de <a href="http://www.google.com">Google</a> pour choisir le premier
site  la recherche contenant ce mot.</i></p>

<p class="gros">Vous allez donc tre redirigs dans 5 secondes vers le site le plus pertinent pour google au mot cl: </p>
<p class="centrergros"> <strong><?php echo $mot?></strong> (langue: <?php echo $langues[$lang];?>)</p>
<?php //'
		 
		 fin_html();
  }
  else{?>
	<html>
	  <head>
	  <meta http-equiv="Refresh" content="0;url=<?php echo $url;?>">
	  </head>
	  <body>
	  </body>
	  </html>
	  <?php
	  }
 }
 else {
   if (isset($HTTP_GET_VARS["apropos"])) {
	 debut_html("", $lang);
	 ?>
	   <p><a href="?lang=<?php echo $lang;?>">Retour  la <b>Random Home Page</b></a>
		  </p>
		  <p><b>Ramdom Web Page</b> est un site trs simple, qui permet de surfer alatoirement sur internet, de s'y promener, de flaner
au fil des clics...
</p>
<h2>Comment a marche</h2>
<p>Le fonctionnement de ce site est trs simple. Il utilise la fonction <b>J'ai de la chance</b> de
  <a href="http://www.google.com">Google</a>. Cette fonction disponible en premire page du moteur de recherche permet
   partir d'un mot cl (d'une recherche quelconque) de rediriger l'internaute vers le site qui lui semble le plus pertinent.
  En gros, <b>J'ai de la chance</b> renvoie directement sur le premier site qui correspond  la recherche.
</p>
<p>Le site <b>Random Web Page</b> choisi donc alatoirement un mot cl de recherche parmi une base de mots (dans une langue
  donne) et utilise google pour trouver la page la plus pertinente sur le sujet, dans la langue choisie par l'utilisateur.
</p>
<p>Utiliser le lien <i>avec le dtail</i> de la page principale permet de connaitre le mot qui a servi  la recherche. Mais ce
  n'est pas indispensable pour apprcier une balade numrique sur la toile.
</p>
<h2>Quelle base de mots cls le site utilise-t-il?</h2>
<p>la base de donnes utilise est la liste de mots franais (ou tasunien pour la version anglaise) propose par
  <a href="http://www.debian.org">debian</a> dans sa distribution GNU/Linux. Elle a initialement t tlcharge depuis
  <a href="ftp://ftp.ox.ac.uk/pub/wordlists/french/dico.Z">ftp.ox.ac.uk</a>, qui propose un large choix de listes de mots.
  Cette liste est sous licence GPL, et est donc librement utilisable. La version franaise contient 140 031 mots (dont
  des verbes conjugus), la version anglaise 96 274 mots, la version espagnole 86 061 mots, et la version
  allemande 160 086 mots. </p>
<p>
  Les mots franais sont convertis en supprimant les accents. Tout d'abord, cela ne nuit pas  la recherche:
  google ne tient pas compte des accents dans ses recherches. Ensuite, la prsence de ces accents peut nuire au
  fonctionnement du site: dans certains cas, les lettres accentues sont remplaces par le caractre "?". Supprimer
  les accents permet donc de contourner ce problme.
</p>
<p>Les recherches ralises dans <i>toutes les langues</i> choisissent un mot alatoirement dans tous les dictionnaires
  disponibles sur le site.
</p>
<h2>Mise en garde</h2>
<p>Le fonctionnement de ce site fonctionnant sur la fonction <i>J'ai de la chance</i> de Google, il est impossible
  techniquement de restreindre les requtes. Ainsi, tous les sites internet sont potentiellement accessibles via
  <b>Random Web Page</b>. Aussi bien les sites de musique que les sites de chasse ou pornographiques.
  <b><i>Certaines pages peuvent donc choquer
  la sensibilit</i></b>. L'auteur de <b>Random Web Page</b> ne peut en rien tre tenu responsable.
</p>
<h2>Pourquoi un seul mot-cl?</h2>
<p>Aprs quelques essais, je me suis dit qu'il serait plus intressant d'utiliser plusieurs mots-cls dans la recherche
  au lieu d'un seul: cela augmenterais le nombre de sites potientiellement joignables. Mais cette ide n'est pas bonne. En effet,
  aprs l'avoir mise en pratique avec 3 puis 2 mots issus de la liste, je me suis rendu compte que peu de ces recherchse
  aboutissaient. Pour de nombreuses combinaisons, google n'a pas de site  proposer. <b>Random Web Page</b> n'aurait donc
  pu fonctionner parfaitement, car de nombreux clics auraient aboutis au message de google
  <i>Essayez avec cette orthographe: ...</i>. C'est donc sur un choix de mot unique que se base l'algorithme utilis.
</p>
<h2>Est-ce vraiment alatoire?</h2>
<p>Diffrents lments viennent limiter l'aspect rellement alatoire de ce site. Tout d'abord, une fonction informatique
  ne peut qu'tre pseudo-alatoire: en informatique, l'<i>alatoire</i> n'existe pas. Mais on peut s'en contenter. Ensuite,
  ce site utilise une base de donnes dont la taille est trs infrieure au nombre de pages d'internet: toutes les pages ne
  sont pas accessibles  partir de ce site (pour rappel, le dictionnaire franais utilis comporte environ 140 000 mots).
  Heureusement, on peut compter sur les mises  jour frquentes de google pour esprer que les 140 000 sites associs 
  ces mots voluent au cours du temps: on ne tombera donc pas toujours sur les mmes sites. Il est d'ailleurs intressant
  de remarquer que les sites que l'on visitera  partir de <b>Random Home Page</b> sont les sites les mieux classs pour
  une recherche donne: les sites mal rfrencs, ou peu apprcis seront difficilement atteignables.
</p>
<h2>Licence: GPL</h2>
<p style="padding-bottom: 4em;">Ce site est ralis  partir d'une base de donnes sous licence GPL. J'ai aussi choisi de placer son code source php
  sous la mme licence (GPL donc). Le lien suivant permet de visualiser le <a href="?codesource=1">code source du programme</a>, et le rpertoire
  des dictionnaires utiliss est <a href="liste/">le suivant</a>. Vous trouverez la feuille de style CSS associe <a href="style.css">ici</a>.
</p>
<h2>Ides d'amliorations (TODO)</h2>
<p>J'aime bien l'aspect de la page principale du site, trs simple. Mais on m'a fait part de plusieurs
  amliorations possibles, de variations  apporter  l'algorithme de choix de la page.
</p>
<p>
  je pense donc runir ces diffrentes amliorations dans une page supplmentaire.. Voici quelques unes de ces ides:
</p>
<ul>
  <li>[<a href="http://emmanuel.bouthenot.free.fr">manu</a>] Restreindre la recherche aux pages html (viter les pages au format exotique comme le doc, pdf, ...);</li>
  <li>[morgan] Proposer une boite de saisie pour laisser l'utilisateur choisir le mot-cl utilis (<i>en gros, faire un relook de google j'ai de la chance? ;)</i>).</li>
  <li>[<a href="http://jm.trivial.free.fr">jmtrivial</a>] Traduire l'interface et cette page.</li>
</ul>
<p>Aprs quelques discussions sur <a href="http://linuxfr.org/~trivial/18613.html">un journal de linuxfr.org</a>, voici quelques amliorations  envisager:</p>
<ul>
  <li>[<a href="http://linuxfr.org/~PsychoFox/">PsychoFox</a>] Proposer de choisir aussi alatoirement la langue du mot cl;</li>
  <li>[<a href="http://linuxfr.org/~milosh/">milosh</a>] Utiliser <i>filetype:html</i> dans la requte vers google est une solution  la promosition de manu;</li>
  <li>[<a href="http://linuxfr.org/~olosta/">olosta</a>] Combiner plusieurs mots dans la recherche, et utiliser la proposition d'orthographe faite par google
  (<i>malheureusement ne marche pas tout le temps non plus</i>)</li>
</ul>
<h2>Amliorations ralises depuis la premire version:</h2>
<p>Voici les quelques amliorations dj ralises depuis la premire version:</p>
<ul>
  <li>[morgan] <i>Restreindre la recherche aux pages en franais (car mme en utilisant le dictionnaire franais,
  il n'est pas assur que la page pointe soit en franais)</i>: ajout du choix de la langue du site utilis</li>
</ul>
<?php //'
fin_html();
}
 else {
   debut_html("", $lang);
   ?>
	 <p>La page sera choisie au hasard parmi les sites en <b><?php echo $langues[$lang];?></b></p>
<p class="centrer"><a href="?randompage=1&amp;lang=<?php echo $lang;?>">visiter une page au hasard</a></p>
<p class="droit">(ou <a href="?randompage=1&amp;detail=1&amp;lang=<?php echo $lang;?>">avec le dtail</a>)</p>
<?php //'
  fin_html();
 }
}

?> 

